<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.1.189">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>EDoN Secure Research Environment Wiki - Using Containers to Share and Reproduce Your Work</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1.6em;
  vertical-align: middle;
}
pre > code.sourceCode { white-space: pre; position: relative; }
pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
pre > code.sourceCode > span:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode > span { color: inherit; text-decoration: inherit; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
pre > code.sourceCode { white-space: pre-wrap; }
pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
}
pre.numberSource code
  { counter-reset: source-line 0; }
pre.numberSource code > span
  { position: relative; left: -4em; counter-increment: source-line; }
pre.numberSource code > span > a:first-child::before
  { content: counter(source-line);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {   }
@media screen {
pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { color: #008000; } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { color: #008000; font-weight: bold; } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
</style>


<script src="../site_libs/quarto-nav/quarto-nav.js"></script>
<script src="../site_libs/clipboard/clipboard.min.js"></script>
<script src="../site_libs/quarto-search/autocomplete.umd.js"></script>
<script src="../site_libs/quarto-search/fuse.min.js"></script>
<script src="../site_libs/quarto-search/quarto-search.js"></script>
<meta name="quarto:offset" content="../">
<link href="../reproducibility/gitlab.html" rel="prev">
<link href="../images/EDoN.png" rel="icon" type="image/png">
<script src="../site_libs/quarto-html/quarto.js"></script>
<script src="../site_libs/quarto-html/popper.min.js"></script>
<script src="../site_libs/quarto-html/tippy.umd.min.js"></script>
<script src="../site_libs/quarto-html/anchor.min.js"></script>
<link href="../site_libs/quarto-html/tippy.css" rel="stylesheet">
<link href="../site_libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="../site_libs/bootstrap/bootstrap.min.js"></script>
<link href="../site_libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="../site_libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">
<script id="quarto-search-options" type="application/json">{
  "location": "navbar",
  "copy-button": false,
  "collapse-after": 3,
  "panel-placement": "end",
  "type": "overlay",
  "limit": 20,
  "language": {
    "search-no-results-text": "No results",
    "search-matching-documents-text": "matching documents",
    "search-copy-link-title": "Copy link to search",
    "search-hide-matches-text": "Hide additional matches",
    "search-more-match-text": "more match in this document",
    "search-more-matches-text": "more matches in this document",
    "search-clear-button-title": "Clear",
    "search-detached-cancel-button-title": "Cancel",
    "search-submit-button-title": "Submit"
  }
}</script>


<link rel="stylesheet" href="../styles.css">
<meta property="og:title" content="EDoN Secure Research Environment Wiki - Using Containers to Share and Reproduce Your Work">
<meta property="og:description" content="Containers allow a researcher to package up a project with all of the parts it needs - such as libraries, dependencies, and system settings - and ship it all out as one package.">
<meta property="og:site-name" content="EDoN Secure Research Environment Wiki">
<meta name="twitter:title" content="EDoN Secure Research Environment Wiki - Using Containers to Share and Reproduce Your Work">
<meta name="twitter:description" content="Containers allow a researcher to package up a project with all of the parts it needs - such as libraries, dependencies, and system settings - and ship it all out as one package.">
<meta name="twitter:card" content="summary">
</head>

<body class="nav-sidebar docked nav-fixed">

<div id="quarto-search-results"></div>
  <header id="quarto-header" class="headroom fixed-top">
    <nav class="navbar navbar-expand-lg navbar-dark ">
      <div class="navbar-container container-fluid">
      <div class="navbar-brand-container">
    <a href="../index.html" class="navbar-brand navbar-brand-logo">
    <img src="../images/EDoN-Logo-Purple-print.jpg" alt="" class="navbar-logo">
    </a>
    <a class="navbar-brand" href="../index.html">
    <span class="navbar-title">EDoN Secure Research Environment Wiki</span>
    </a>
  </div>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">
  <span class="navbar-toggler-icon"></span>
</button>
          <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav navbar-nav-scroll me-auto">
  <li class="nav-item">
    <a class="nav-link" href="../index.html">Home</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link active" href="../get-started/index.html" aria-current="page">Get Started</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link" href="../blog/index.qmd">Blog</a>
  </li>  
</ul>
              <div id="quarto-search" class="" title="Search"></div>
          </div> <!-- /navcollapse -->
      </div> <!-- /container-fluid -->
    </nav>
  <nav class="quarto-secondary-nav" data-bs-toggle="collapse" data-bs-target="#quarto-sidebar" aria-controls="quarto-sidebar" aria-expanded="false" aria-label="Toggle sidebar navigation" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">
    <div class="container-fluid d-flex justify-content-between">
      <h1 class="quarto-secondary-nav-title">Using Containers to Share and Reproduce Your Work</h1>
      <button type="button" class="quarto-btn-toggle btn" aria-label="Show secondary navigation">
        <i class="bi bi-chevron-right"></i>
      </button>
    </div>
  </nav>
</header>
<!-- content -->
<div id="quarto-content" class="quarto-container page-columns page-rows-contents page-layout-article page-navbar">
<!-- sidebar -->
  <nav id="quarto-sidebar" class="sidebar collapse sidebar-navigation docked overflow-auto">
      <div class="mt-2 flex-shrink-0 align-items-center">
        <div class="sidebar-search">
        <div id="quarto-search" class="" title="Search"></div>
        </div>
      </div>
    <div class="sidebar-menu-container"> 
    <ul class="list-unstyled mt-1">
        <li class="sidebar-item sidebar-item-section">
      <div class="sidebar-item-container"> 
            <a class="sidebar-item-text sidebar-link text-start" data-bs-toggle="collapse" data-bs-target="#quarto-sidebar-section-1" aria-expanded="true">Get Started</a>
          <a class="sidebar-item-toggle text-start" data-bs-toggle="collapse" data-bs-target="#quarto-sidebar-section-1" aria-expanded="true">
            <i class="bi bi-chevron-right ms-2"></i>
          </a> 
      </div>
      <ul id="quarto-sidebar-section-1" class="collapse list-unstyled sidebar-section depth1 show">  
          <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="../get-started/index.html" class="sidebar-item-text sidebar-link">Getting Started</a>
  </div>
</li>
      </ul>
  </li>
        <li class="sidebar-item sidebar-item-section">
      <div class="sidebar-item-container"> 
            <a class="sidebar-item-text sidebar-link text-start" data-bs-toggle="collapse" data-bs-target="#quarto-sidebar-section-2" aria-expanded="true">Reproducibility Guides</a>
          <a class="sidebar-item-toggle text-start" data-bs-toggle="collapse" data-bs-target="#quarto-sidebar-section-2" aria-expanded="true">
            <i class="bi bi-chevron-right ms-2"></i>
          </a> 
      </div>
      <ul id="quarto-sidebar-section-2" class="collapse list-unstyled sidebar-section depth1 show">  
          <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="../reproducibility/index.html" class="sidebar-item-text sidebar-link">Reproducible Research</a>
  </div>
</li>
          <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="../reproducibility/gitlab.html" class="sidebar-item-text sidebar-link">GitLab</a>
  </div>
</li>
          <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="../reproducibility/containers.html" class="sidebar-item-text sidebar-link active">Using Containers to Share and Reproduce Your Work</a>
  </div>
</li>
      </ul>
  </li>
    </ul>
    </div>
</nav>
<!-- margin-sidebar -->
    <div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
        <nav id="TOC" role="doc-toc" class="toc-active">
    <h2 id="toc-title">On this page</h2>
   
  <ul>
  <li><a href="#what-are-containers" id="toc-what-are-containers" class="nav-link active" data-scroll-target="#what-are-containers">What are Containers?</a></li>
  <li><a href="#what-are-images" id="toc-what-are-images" class="nav-link" data-scroll-target="#what-are-images">What are Images?</a></li>
  <li><a href="#docker" id="toc-docker" class="nav-link" data-scroll-target="#docker">Docker</a></li>
  <li><a href="#head" id="toc-head" class="nav-link" data-scroll-target="#head">&lt;&lt;&lt;&lt;&lt;&lt;&lt; HEAD</a>
  <ul class="collapse">
  <li><a href="#docker-in-the-sre" id="toc-docker-in-the-sre" class="nav-link" data-scroll-target="#docker-in-the-sre">Docker in the SRE</a></li>
  <li><a href="#how-to-install-a-docker-container" id="toc-how-to-install-a-docker-container" class="nav-link" data-scroll-target="#how-to-install-a-docker-container">How to install a Docker Container?</a></li>
  <li><a href="#running-docker-containers" id="toc-running-docker-containers" class="nav-link" data-scroll-target="#running-docker-containers">Running Docker Containers</a>
  <ul class="collapse">
  <li><a href="#what-does-this-do" id="toc-what-does-this-do" class="nav-link" data-scroll-target="#what-does-this-do">What does this do?</a></li>
  </ul></li>
  <li><a href="#advantages-of-using-containers" id="toc-advantages-of-using-containers" class="nav-link" data-scroll-target="#advantages-of-using-containers">Advantages of using containers</a></li>
  </ul></li>
  </ul>
<div class="toc-actions"><div><i class="bi bi-git"></i></div><div class="action-links"><p><a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/-/tree/main/edit/main/reproducibility/containers.qmd" class="toc-action">Edit this page</a></p><p><a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/-/tree/main/issues/new" class="toc-action">Report an issue</a></p></div></div></nav>
    </div>
<!-- main -->
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title d-none d-lg-block">Using Containers to Share and Reproduce Your Work</h1>
</div>



<div class="quarto-title-meta">

    
    
  </div>
  

</header>

<section id="what-are-containers" class="level2">
<h2 class="anchored" data-anchor-id="what-are-containers">What are Containers?</h2>
<p>Containers allow a researcher to package up a project with all of the parts it needs - such as libraries, dependencies, and system settings - and ship it all out as one package. Anyone can then open up a container and work within it, viewing and interacting with the project as if the machine they are accessing it from is identical to the machine specified in the container - regardless of what their computational environment actually is. They are designed to make it easier to transfer projects between very different environments.</p>
</section>
<section id="what-are-images" class="level2">
<h2 class="anchored" data-anchor-id="what-are-images">What are Images?</h2>
<p>Images are the files used to generate containers. Containers are then identical copies instantiated from images. We can build a container from an image with the following steps:</p>
<ul>
<li><p>A recipe file a human writes contains all the steps to generate a working version of the project and its computational environment, but no actual materials. Think of this as a blueprint.</p></li>
<li><p>Building an image takes that recipe and using it, assembles all the packages, software libraries, and configurations needed to make the full-fledged project and environment, and bundles them up in a condensed lump. Think of images like a piece of flat-pack furniture made using the blueprint.</p></li>
<li><p>Containers take that image and assemble a fully working version of the project and the environment needed to run it. Think of this as assembling the flat-pack furniture.</p></li>
</ul>
<p>So if a researcher wants to allow others to reproduce their work, they would need to write a recipe file, and use it to build an image of their project. They can then share this image file with anyone who wants to replicate their work. That person can then use the image to generate a container containing a working version of the project.</p>
</section>
<section id="docker" class="level2">
<h2 class="anchored" data-anchor-id="docker">Docker</h2>
<p>EDoN makes use of a containerization tool called Docker. In Docker, the recipe files used to generate images are known as Dockerfiles, and should be named <code>Dockerfile</code>. A simple <code>Dockerfile</code> that builds a container with python installed might look like:</p>
</section>
<section id="head" class="level1">
<h1>&lt;&lt;&lt;&lt;&lt;&lt;&lt; HEAD</h1>
<div class="cell">
<div class="sourceCode cell-code" id="cb1"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a>FROM python<span class="sc">:</span><span class="fl">3.8</span><span class="sc">-</span>slim<span class="sc">-</span>buster</span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-3"><a href="#cb1-3" aria-hidden="true" tabindex="-1"></a>WORKDIR <span class="sc">/</span>app</span>
<span id="cb1-4"><a href="#cb1-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-5"><a href="#cb1-5" aria-hidden="true" tabindex="-1"></a>COPY requirements.txt requirements.txt</span>
<span id="cb1-6"><a href="#cb1-6" aria-hidden="true" tabindex="-1"></a>RUN pip3 install <span class="sc">-</span>r requirements.txt</span>
<span id="cb1-7"><a href="#cb1-7" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-8"><a href="#cb1-8" aria-hidden="true" tabindex="-1"></a>COPY . .</span>
<span id="cb1-9"><a href="#cb1-9" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-10"><a href="#cb1-10" aria-hidden="true" tabindex="-1"></a>CMD [ <span class="st">"python3"</span>, <span class="st">"-m"</span> , <span class="st">"flask"</span>, <span class="st">"run"</span>, <span class="st">"--host=0.0.0.0"</span>]</span></code><button title="Copy to Clipboard" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<blockquote class="blockquote">
<blockquote class="blockquote">
<blockquote class="blockquote">
<blockquote class="blockquote">
<blockquote class="blockquote">
<blockquote class="blockquote">
<blockquote class="blockquote">
<p>3042b544c884208928711e7f9dec864f40e9c647</p>
</blockquote>
</blockquote>
</blockquote>
</blockquote>
</blockquote>
</blockquote>
</blockquote>
<p>We can then install this container on any machine and run code using only resources from within the container. This is a clean way to run someone elses python code that requires a different version of python that on your local machine.</p>
<section id="docker-in-the-sre" class="level2">
<h2 class="anchored" data-anchor-id="docker-in-the-sre">Docker in the SRE</h2>
<p>We make use of GitLab CI/CD Pipelines in the SRE to build Docker containers. For example, the Docker container used to setup R and Python for this Wiki are stored and built from <a href="https://gitlab.com/arronlacey/r_miniconda_container/-/tree/main">this GitLab Repository</a>. There are two files of interest - the first is the <code>Dockerfile</code>, similar to the example above, and the second is a <code>.gitlab-ci.yml</code> file which looks like this:</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb2"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb2-1"><a href="#cb2-1" aria-hidden="true" tabindex="-1"></a>image<span class="sc">:</span> gitlab<span class="sc">/</span>dind</span>
<span id="cb2-2"><a href="#cb2-2" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-3"><a href="#cb2-3" aria-hidden="true" tabindex="-1"></a>services<span class="sc">:</span></span>
<span id="cb2-4"><a href="#cb2-4" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> docker<span class="sc">:</span>dind</span>
<span id="cb2-5"><a href="#cb2-5" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-6"><a href="#cb2-6" aria-hidden="true" tabindex="-1"></a>variables<span class="sc">:</span></span>
<span id="cb2-7"><a href="#cb2-7" aria-hidden="true" tabindex="-1"></a>  DOCKER_HOST<span class="sc">:</span> tcp<span class="sc">:</span><span class="er">//</span>docker<span class="sc">:</span><span class="dv">2375</span></span>
<span id="cb2-8"><a href="#cb2-8" aria-hidden="true" tabindex="-1"></a>  DOCKER_DRIVER<span class="sc">:</span> overlay2</span>
<span id="cb2-9"><a href="#cb2-9" aria-hidden="true" tabindex="-1"></a>  CONTAINER_TEST_IMAGE<span class="sc">:</span> <span class="er">$</span>CI_REGISTRY_IMAGE</span>
<span id="cb2-10"><a href="#cb2-10" aria-hidden="true" tabindex="-1"></a>  SHARED_PATH<span class="sc">:</span> <span class="er">/</span>builds<span class="sc">/</span>shared<span class="sc">/</span><span class="er">$</span>CI_PROJECT_PATH</span>
<span id="cb2-11"><a href="#cb2-11" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-12"><a href="#cb2-12" aria-hidden="true" tabindex="-1"></a>stages<span class="sc">:</span></span>
<span id="cb2-13"><a href="#cb2-13" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> build</span>
<span id="cb2-14"><a href="#cb2-14" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> deploy</span>
<span id="cb2-15"><a href="#cb2-15" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-16"><a href="#cb2-16" aria-hidden="true" tabindex="-1"></a>build_image<span class="sc">:</span></span>
<span id="cb2-17"><a href="#cb2-17" aria-hidden="true" tabindex="-1"></a>  stage<span class="sc">:</span> build</span>
<span id="cb2-18"><a href="#cb2-18" aria-hidden="true" tabindex="-1"></a>  script<span class="sc">:</span></span>
<span id="cb2-19"><a href="#cb2-19" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> docker login <span class="sc">-</span>u <span class="sc">$</span>CI_REGISTRY_USER <span class="sc">-</span>p <span class="sc">$</span>CI_REGISTRY_PASSWORD <span class="sc">$</span>CI_REGISTRY</span>
<span id="cb2-20"><a href="#cb2-20" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> mkdir <span class="sc">-</span>p <span class="sc">$</span>{SHARED_PATH}</span>
<span id="cb2-21"><a href="#cb2-21" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> docker build <span class="sc">--</span>pull <span class="sc">-</span>t <span class="sc">$</span>CONTAINER_TEST_IMAGE<span class="sc">:</span>latest .</span>
<span id="cb2-22"><a href="#cb2-22" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> docker push <span class="sc">$</span>CONTAINER_TEST_IMAGE</span>
<span id="cb2-23"><a href="#cb2-23" aria-hidden="true" tabindex="-1"></a>  rules<span class="sc">:</span></span>
<span id="cb2-24"><a href="#cb2-24" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> changes<span class="sc">:</span></span>
<span id="cb2-25"><a href="#cb2-25" aria-hidden="true" tabindex="-1"></a>      <span class="sc">-</span> Dockerfile</span>
<span id="cb2-26"><a href="#cb2-26" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-27"><a href="#cb2-27" aria-hidden="true" tabindex="-1"></a>pages<span class="sc">:</span></span>
<span id="cb2-28"><a href="#cb2-28" aria-hidden="true" tabindex="-1"></a>  stage<span class="sc">:</span> deploy</span>
<span id="cb2-29"><a href="#cb2-29" aria-hidden="true" tabindex="-1"></a>  image<span class="sc">:</span> <span class="er">$</span>CONTAINER_TEST_IMAGE<span class="sc">:</span>latest</span>
<span id="cb2-30"><a href="#cb2-30" aria-hidden="true" tabindex="-1"></a>  script<span class="sc">:</span></span>
<span id="cb2-31"><a href="#cb2-31" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> Rscript <span class="sc">-</span>e <span class="st">"quarto::quarto_render('index.qmd', output_file = 'index.html')"</span></span>
<span id="cb2-32"><a href="#cb2-32" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> mkdir public</span>
<span id="cb2-33"><a href="#cb2-33" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> cp <span class="sc">-</span>r docs<span class="sc">/</span><span class="er">*</span> public<span class="sc">/</span></span>
<span id="cb2-34"><a href="#cb2-34" aria-hidden="true" tabindex="-1"></a>  artifacts<span class="sc">:</span></span>
<span id="cb2-35"><a href="#cb2-35" aria-hidden="true" tabindex="-1"></a>    paths<span class="sc">:</span></span>
<span id="cb2-36"><a href="#cb2-36" aria-hidden="true" tabindex="-1"></a>    <span class="sc">-</span> public</span>
<span id="cb2-37"><a href="#cb2-37" aria-hidden="true" tabindex="-1"></a>  only<span class="sc">:</span></span>
<span id="cb2-38"><a href="#cb2-38" aria-hidden="true" tabindex="-1"></a>  <span class="sc">-</span> main</span>
<span id="cb2-39"><a href="#cb2-39" aria-hidden="true" tabindex="-1"></a>  interruptible<span class="sc">:</span> true</span></code><button title="Copy to Clipboard" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>The <code>.gitlab-ci.yml</code> file has instructions to run a pipeline (a CI/CD pipeline) - in this case building a container from a <code>Dockerfile</code> image. CI/CD pipelines can be configured to run many different pipelines such as rendering latex files, spinning up a Jupyter Notebook with pre-loaded code and data, or building a static website (like this Wiki - see the <code>deploy</code> stage in the <code>.gitlab-ci.yml</code> file). The resulting container that can be downloaded an installed on any machine is stored within the Container Registry within the GitLab repository - see <a href="https://gitlab.com/arronlacey/r_miniconda_container/container_registry">here</a> for the link.</p>
</section>
<section id="how-to-install-a-docker-container" class="level2">
<h2 class="anchored" data-anchor-id="how-to-install-a-docker-container">How to install a Docker Container?</h2>
<p>EDoN SRE Desktops come pre-loaded with <code>docker</code> - making it easy to install docker containers. To install the Docker container that builds this Wiki you can open up a terminal and type the following:</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb3"><pre class="sourceCode bash code-with-copy"><code class="sourceCode bash"><span id="cb3-1"><a href="#cb3-1" aria-hidden="true" tabindex="-1"></a><span class="ex">docker</span> pull registry.gitlab.com/edon-initiative/containers/edon-sre-wiki</span></code><button title="Copy to Clipboard" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Everytime you run this command, <code>docker</code> checks the GitLab Container Registry for the repository and if there has been an update to the container, <code>docker</code> will download an overwrite your local image with the latest (you can specify different behaviour though if you like).</p>
</section>
<section id="running-docker-containers" class="level2">
<h2 class="anchored" data-anchor-id="running-docker-containers">Running Docker Containers</h2>
<p>Before you run a Docker container an important consideration to make is that they are ephemeral and anything you do with a docker container gets reset as soon as you close it. While it is possible to commit changes made to a Docker container i.e.&nbsp;writing some R code or installing a new python package within the container, this is not recomended because unlike in a Dockerfile these changes aren’t easily tracked and hence a barrier to reproducability (which is why the default behaviour of a container is to reset after you have finished using it). A much better way to use a Docker container is to mount local directories to the running containers and change <em>those</em> files, and if you want to install new packages - experiment by installing in the running docker container, but then after you are happy <em>change the Dockerfile</em> on GitLab to include them and re-run the GitLab CI/CD pipeline, thus creating a new container for anyone else to use.</p>
<p>Let’s run a docker container and attach a local directory to it - this directory might be a cloned GitHub/GitLab repository that contains a Python project. For now let’s run the docker container that builds this Wiki:</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb4"><pre class="sourceCode bash code-with-copy"><code class="sourceCode bash"><span id="cb4-1"><a href="#cb4-1" aria-hidden="true" tabindex="-1"></a><span class="ex">docker</span> run <span class="at">--rm</span> <span class="at">-p</span> 8787:8787 <span class="at">-v</span> <span class="va">${PWD}</span>:/mnt registry.gitlab.com/edon-initiative/containers/edon-sre-wiki</span></code><button title="Copy to Clipboard" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<section id="what-does-this-do" class="level3">
<h3 class="anchored" data-anchor-id="what-does-this-do">What does this do?</h3>
<ul>
<li>Loads runs the docker container downloaded in the previous step</li>
<li>Attaches the current directory on your local machine <code>${PWD}</code> to the <code>/mnt</code> directory within the container</li>
<li>Opens up port 8787 to serve an application (in this case RStudio Server) in localhost:8787 in your browser</li>
</ul>
<p>There are 3 ways you might want to interact with this container from this point:</p>
<ul>
<li><ol type="1">
<li>Head to <a href="https:/localhost:8787%5D">https:/localhost:8787</a> in your browser to access RStudio Server (or whatever application is configured to run by default - maybe Jupyter?)</li>
</ol></li>
<li><ol start="2" type="1">
<li>Attach A Visual Studio Code editor to the container using the Docker Extension for Visual Studio Code (tutorial to follow…)</li>
</ol></li>
<li><ol start="3" type="1">
<li>Open up a shell to the running Docker container (especially useful if you want to install dependencies to experiment with)</li>
</ol></li>
</ul>
<div class="cell">
<div class="sourceCode cell-code" id="cb5"><pre class="sourceCode bash code-with-copy"><code class="sourceCode bash"><span id="cb5-1"><a href="#cb5-1" aria-hidden="true" tabindex="-1"></a><span class="ex">docker</span> exec <span class="at">-it</span> <span class="op">&lt;</span>container instance alias<span class="op">&gt;</span> /bin/bash</span></code><button title="Copy to Clipboard" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Since you have mounted your local directory to the container, any changes you make to it happen on your local machine where just happen to be <em>borrowing</em> the machine provided by the Docker Container.</p>
</section>
</section>
<section id="advantages-of-using-containers" class="level2">
<h2 class="anchored" data-anchor-id="advantages-of-using-containers">Advantages of using containers</h2>
<p>The above workflow gives us some great advantages:</p>
<ul>
<li>How frustrating is it when you run some code in a tutorial online - even one in a nice Jupyter Notebook, and the code doesn’t work on your machine? There could be many reasons for this - but if the author provides a docker container then most of these problems go away because you can <em>use the same compute environment</em> they had used when running their code - all provided by the Docker container.</li>
<li>If we want to deploy a machine learning model on a server that is running a live prediction service for the EDoN toolkit - we won’t have the luxury of devloping that model on the live server (remember Gary Sinise’s character from Apollo 13 trying to figure out how to save his colleagues in space from within a simulation environment?). Therefore we must ensure our models that work just fine on our local machines will also work on a live server. Containers help a long way with that!</li>
<li>It is easy to imagine EDoN researchers experimenting with code and then wanting to share it with your colleagues - envs and renvs aside - we may be using different versions of R or Python (the latter can be quite backwards incompatible) that causes runtime issues. By baking containers into your workflow we can avoid this - or even better - together we can maintain a containers shop that we recommend for certain tasks.</li>
<li>Containers help keep our work lean - if we only ever use one compute environment for the entireity of the EDoN project, but only a few select models are published and used in the EDoN toolkit - it’s likely we will collect redundencies that bloat out production servers and put us into technical debt by having more things that can go wrong.</li>
<li>….Or we have to try and reproduce our own work from 3 years ago in a separate environment ready to go into the EDoN Toolkit servers :scream:</li>
</ul>


</section>
</section>

</main> <!-- /main -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    target: function(trigger) {
      return trigger.previousElementSibling;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    setTimeout(function() {
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn) {
    const config = {
      allowHTML: true,
      content: contentFn,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start'
    };
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const cites = ref.parentNode.getAttribute('data-cites').split(' ');
    tippyHover(ref, function() {
      var popup = window.document.createElement('div');
      cites.forEach(function(cite) {
        var citeDiv = window.document.createElement('div');
        citeDiv.classList.add('hanging-indent');
        citeDiv.classList.add('csl-entry');
        var biblioDiv = window.document.getElementById('ref-' + cite);
        if (biblioDiv) {
          citeDiv.innerHTML = biblioDiv.innerHTML;
        }
        popup.appendChild(citeDiv);
      });
      return popup.innerHTML;
    });
  }
});
</script>
<nav class="page-navigation">
  <div class="nav-page nav-page-previous">
      <a href="../reproducibility/gitlab.html" class="pagination-link">
        <i class="bi bi-arrow-left-short"></i> <span class="nav-page-text">GitLab</span>
      </a>          
  </div>
  <div class="nav-page nav-page-next">
  </div>
</nav>
</div> <!-- /content -->
<footer class="footer">
  <div class="nav-footer">
    <div class="nav-footer-left">Proudly supported by <a href="https://www.rstudio.com"><img src="https://www.rstudio.com/wp-content/uploads/2018/10/RStudio-Logo-flat.svg" class="img-fluid" alt="RStudio" width="65"></a></div>   
      <div class="nav-footer-center">
        <ul class="footer-items list-unstyled">
    <li class="nav-item">
    <a class="nav-link" href="../about.html">About</a>
  </li>  
</ul>
      </div>
    <div class="nav-footer-right">
      <ul class="footer-items list-unstyled">
    <li class="nav-item compact">
    <a class="nav-link" href="https://github.com/rstudio/vetiver.rstudio.com">
      <i class="bi bi-github" role="img" aria-label="Vetiver site GitHub">
</i> 
    </a>
  </li>  
</ul>
    </div>
  </div>
</footer>



</body></html>